Summary: The Berkeley DB database library for C
Name: libdb
Version: 5.3.28
Release: 5%{?dist}
License: BSD and LGPLv2 and Sleepycat
URL: http://www.oracle.com/database/berkeley-db/
Source0: http://download.oracle.com/berkeley-db/db-%{version}.tar.gz
Source1: http://download.oracle.com/berkeley-db/db.1.85.tar.gz
Source2: http://www.gnu.org/licenses/lgpl-2.1.txt
Source3: libdb-5.3.28-manpages.tar.gz

Patch0001: http://www.oracle.com/technology/products/berkeley-db/db/update/1.85/patch.1.1
Patch0002: http://www.oracle.com/technology/products/berkeley-db/db/update/1.85/patch.1.2
Patch0003: http://www.oracle.com/technology/products/berkeley-db/db/update/1.85/patch.1.3
Patch0004: http://www.oracle.com/technology/products/berkeley-db/db/update/1.85/patch.1.4

Patch3000: db-1.85-errno.patch
Patch3001: db-4.6.21-1.85-compat.patch
Patch3002: db-4.5.20-jni-include-dir.patch
Patch3003: 007-mt19937db.c_license.patch
Patch3004: db-5.3.21-memp_stat-upstream-fix.patch
Patch3005: db-5.3.21-mutex_leak.patch
Patch3006: db-5.3.28-lemon_hash.patch
Patch3007: db-5.3.28-condition_variable.patch
Patch3008: db-5.3.28-condition-variable-ppc.patch
Patch3009: db-5.3.28-rpm-lock-check.patch
Patch3010: db-5.3.28-cwd-db_config.patch
Patch3011: libdb-5.3.21-region-size-check.patch
Patch3012: checkpoint-opd-deadlock.patch
Patch3013: db-5.3.28-atomic_compare_exchange.patch
Patch3014: libdb-cbd-race.patch
Patch3015: libdb-limit-cpu.patch
Patch3016: libdb-5.3.21-trickle_cpu.patch
Patch3017: db-5.3.28_cve-2019-2708.patch
Patch3018: db-5.3.28-mmap-high-cpu-usage.patch

%global __tclversion 8.6
BuildRequires: gcc gcc-c++
BuildRequires: perl-interpreter libtool, chrpath
BuildRequires: tcl-devel >= %{__tclversion}, zlib-devel

Provides: %{name}-utils = %{version}-%{release}
Provides: %{name}-cxx = %{version}-%{release}
Provides: %{name}-tcl = %{version}-%{release}
Provides: %{name}-sql = %{version}-%{release}
Provides: %{name}-java = %{version}-%{release}

%description
Berkeley DB is a family of embedded key-value database libraries providing
scalable high-performance data management services to applications. The Berkeley
DB products use simple function-call APIs for data access and management.
Berkeley DB enables the development of custom data management solutions, without
the overhead traditionally associated with such custom projects. Berkeley DB
provides a collection of well-proven building-block technologies that can be
configured to address any application need from the hand-held device to the
data center, from a local storage solution to a world-wide distributed one,
from kilobytes to petabytes.

%package devel
Summary: C development files for the Berkeley DB library
Requires: %{name} = %{version}-%{release}
Provides: %{name}-devel-doc = %{version}-%{release}
Provides: %{name}-devel-static = %{version}-%{release}
Provides: %{name}-cxx-devel = %{version}-%{release}
Provides: %{name}-tcl-devel = %{version}-%{release}
Provides: %{name}-sql-devel = %{version}-%{release}
Provides: %{name}-java-devel = %{version}-%{release}

%description devel
The Berkeley Database (Berkeley DB) is a programmatic toolkit that
provides embedded database support for both traditional and
client/server applications. This package contains the header files,
libraries, and documentation for building programs which use the
Berkeley DB.

%prep
%setup -q -n db-%{version} -a 1
cp %{SOURCE2} .
tar -xf %{SOURCE3}

pushd db.1.85/PORT/linux
%patch1 -p0
popd
pushd db.1.85
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch3000 -p1
popd

%autopatch -p1 -m 3001 -M 3018

cd dist
./s_config
cd ..

%build
export CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing \
                -DSHAREDSTATEDIR='\"%{_sharedstatedir}\"' \
                -DSQLITE_ENABLE_COLUMN_METADATA=1 \
                -DSQLITE_DISABLE_DIRSYNC=1 \
                -DSQLITE_ENABLE_FTS3=3 \
                -DSQLITE_ENABLE_RTREE=1 \
                -DSQLITE_SECURE_DELETE=1 \
                -DSQLITE_ENABLE_UNLOCK_NOTIFY=1 \
                -I../../../lang/sql/sqlite/ext/fts3/"

make -C db.1.85/PORT/linux OORG="$CFLAGS"

test -d dist/dist-tls || mkdir dist/dist-tls

/bin/sh libtool --tag=CC --mode=compile	%{__cc} $RPM_OPT_FLAGS \
                -Idb.1.85/PORT/linux/include \
                -D_REENTRANT -c util/db_dump185.c \
                -o dist/dist-tls/db_dump185.lo
/bin/sh libtool --tag=LD --mode=link %{__cc} -o dist/dist-tls/db_dump185 \
                dist/dist-tls/db_dump185.lo db.1.85/PORT/linux/libdb.a

for dir in dist lang/sql/sqlite lang/sql/jdbc lang/sql/odbc; do
  cp /usr/lib/rpm/%{_vendor}/config.{guess,sub} "$dir"
done

pushd dist/dist-tls
%define _configure ../configure
%configure -C \
	--enable-compat185 --enable-dump185 \
	--enable-shared --enable-static \
	--enable-tcl --with-tcl=%{_libdir} \
	--enable-cxx --enable-sql \
	--enable-test \
	--disable-rpath \
        --with-tcl=%{_libdir}/tcl%{__tclversion}

perl -pi -e 's/^predep_objects=".*$/predep_objects=""/' libtool
perl -pi -e 's/^postdep_objects=".*$/postdep_objects=""/' libtool
perl -pi -e 's/-shared -nostdlib/-shared/' libtool

%make_build

popd

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_includedir}
mkdir -p %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_mandir}/man1

%make_install STRIP=/bin/true -C dist/dist-tls

rm -rf %{buildroot}%{_prefix}/docs
rm -f %{buildroot}%{_libdir}/{libdb.a,libdb_cxx.a,libdb_tcl.a,libdb_sql.a}
rm -f %{buildroot}%{_libdir}/*.la

chmod +x %{buildroot}%{_libdir}/*.so*

mkdir -p %{buildroot}%{_includedir}/%{name}
mv %{buildroot}%{_includedir}/*.h %{buildroot}%{_includedir}/%{name}/

for i in db.h db_cxx.h db_185.h; do
	ln -s %{name}/$i %{buildroot}%{_includedir}
done

chmod u+w %{buildroot}%{_bindir} %{buildroot}%{_bindir}/*

chrpath -d %{buildroot}%{_libdir}/*.so %{buildroot}%{_bindir}/*

rm -rf docs/csharp
rm -rf docs/installation
rm -rf examples/csharp
mv examples docs
mv man/* %{buildroot}%{_mandir}/man1

%files
%license LICENSE lgpl-2.1.txt
%doc README
%{_libdir}/libdb-*.so
%{_libdir}/libdb_cxx-*.so
%{_libdir}/libdb_tcl-*.so
%{_libdir}/libdb_sql-*.so
%{_bindir}/db*_archive
%{_bindir}/db*_checkpoint
%{_bindir}/db*_deadlock
%{_bindir}/db*_dump*
%{_bindir}/db*_hotbackup
%{_bindir}/db*_load
%{_bindir}/db*_printlog
%{_bindir}/db*_recover
%{_bindir}/db*_replicate
%{_bindir}/db*_stat
%{_bindir}/db*_upgrade
%{_bindir}/db*_verify
%{_bindir}/db*_tuner
%{_mandir}/man1/db_*

%files devel
%{_libdir}/libdb.so
%{_libdir}/libdb-*.a
%{_libdir}/libdb_cxx-*.a
%{_libdir}/libdb_tcl-*.a
%{_libdir}/libdb_sql-*.a
%{_libdir}/libdb_cxx.so
%{_libdir}/libdb_tcl.so
%{_libdir}/libdb_sql.so
%dir %{_includedir}/%{name}
%{_includedir}/%{name}/db.h
%{_includedir}/%{name}/db_185.h
%{_includedir}/db.h
%{_includedir}/db_185.h
%{_includedir}/%{name}/db_cxx.h
%{_includedir}/db_cxx.h
%{_includedir}/%{name}/dbsql.h
%{_bindir}/dbsql

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.3.28-5
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Aug 03 2023 cunshunxia <cunshunxia@tencent.com> - 5.3.28-4
- Rebuilt for tcl 8.6.13

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.3.28-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.3.28-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Jun 7 2022 cunshunxia <cunshunxia@tencent.com> - 5.3.28-1
- initial build
